#====================================================
#	Cycle - calendar for women
#	Distributed under GNU Public License
# Author: Oleg S. Gints (go@altlinux.ru)
# Home page: http://conero.lrn.ru
#====================================================

from wxPython.wx import *
from wxPython.calendar import *
import calendar
import operator

class Val:
    pass
    
MARK_BEGIN  = 1
MARK_FERT   = 1<<1
MARK_OVUL   = 1<<2
MARK_SAFESEX= 1<<3
MARK_TODAY  = 1<<4
MARK_NOTE   = 1<<5
MARK_PROG   = 1<<6
MARK_LAST   = 1<<7 #last cycle, conception begin
MARK_BIRTH  = 1<<8
MARK_TABLET = 1<<9 #1-st hormonal tablet
MARK_T22_28 = 1<<10 #tablets 22-28 or pause 7 days
MARK_NEXT_TABLET = 1<<11 

#-------------------- class Month_Cal -------------------
class Month_Cal(wxCalendarCtrl):
    def __init__(self, parent, id, dt, pos=wxDefaultPosition,
		size=wxDefaultSize, style=0 ):
		
	style = wxCAL_NO_YEAR_CHANGE | wxCAL_NO_MONTH_CHANGE | wxNO_BORDER
	if cycle.first_week_day==0:
	    style = style | wxCAL_MONDAY_FIRST
	else:
	    style = style | wxCAL_SUNDAY_FIRST
	try:
	    style = style | wxCAL_SEQUENTIAL_MONTH_SELECTION
	except NameError:
	    pass
		    
	wxCalendarCtrl.__init__(self, parent, id, dt, pos, size, style)
	self.SetHeaderColours(wxBLACK,wxWHITE)
	if wxPlatform == '__WXMSW__':
	    font = self.GetFont()
	    font.SetFaceName("MS Sans Serif")
	    self.SetFont(font)
	
	EVT_RIGHT_DOWN(self, self.OnRightDown)
	EVT_LEFT_DOWN(self, self.OnLeftDown)
	EVT_KEY_UP(self, self.OnKey)
	EVT_KEY_DOWN(self, self.OnKey)
	self.d_click=wxDateTime()#FromDMY(1, 0,2002)
	
    def OnLeftDown(self, event):
	d=wxDateTimeFromDMY(1, 0,2002)
	if self.HitTest(event.GetPosition(),d)==wxCAL_HITTEST_DAY:
	    Val.frame.SetStatusText(info(d))

    def OnRightDown(self, event):
	d=wxDateTime() # need new object!
	if self.HitTest(event.GetPosition(), d)==wxCAL_HITTEST_DAY:
	    #now d contain clicked day
	    self.d_click=d
	    menu = wxMenu()
	    menu.Append(1, d.Format('%d %B'))
	    menu.AppendSeparator()
	    menu.AppendCheckItem(2, _('Begin of cycle'))#,checkable=TRUE)
	    menu.Check(2,is_set_mark(d, MARK_BEGIN, d.GetYear()))
	    menu.AppendCheckItem(5, _('1-st tablet'))#,checkable=TRUE)
	    menu.Check(5,is_set_mark(d, MARK_TABLET, d.GetYear()))
	    if is_set_mark(d, MARK_BEGIN, d.GetYear()):
		menu.AppendCheckItem(3, _('Conception'))#,checkable=TRUE)
		menu.Check(3,is_set_mark(d, MARK_LAST, d.GetYear()))
	    menu.AppendCheckItem(4, _('Note'))#,checkable=TRUE)
	    menu.Check(4,is_set_mark(d, MARK_NOTE, d.GetYear()))
	    
	    EVT_MENU(self, 2, self.OnBegin)
	    EVT_MENU(self, 3, self.OnLast)
	    EVT_MENU(self, 4, self.OnNote)
	    EVT_MENU(self, 5, self.OnTablet)
	    self.PopupMenu(menu, event.GetPosition())
	    menu.Destroy()

    def OnBegin(self, event):
	if self.d_click in cycle.begin:
	    cycle.begin.remove(self.d_click)
	    if self.d_click in cycle.last:
		cycle.last.remove(self.d_click)
	    remove_mark(self.d_click, MARK_BEGIN, self.d_click.GetYear())
	    remove_mark(self.d_click, MARK_LAST, self.d_click.GetYear())
	else:
	    cycle.begin.append(self.d_click)
	    cycle.begin.sort()
	    add_mark(self.d_click, MARK_BEGIN, self.d_click.GetYear())
	Val.Cal.Draw_Mark()

    def OnLast(self, event):
  	if self.d_click in cycle.begin:
	    if self.d_click in cycle.last:
		cycle.last.remove(self.d_click)
		remove_mark(self.d_click, MARK_LAST, self.d_click.GetYear())
	    else:
		cycle.last.append(self.d_click)
		cycle.last.sort()
		add_mark(self.d_click, MARK_LAST, self.d_click.GetYear())
	    Val.Cal.Draw_Mark()
 
    def OnNote(self, event):
	txt=get_note(self.d_click)
	dlg = Note_Dlg(self, self.d_click.Format('%d %B'), txt)
	ret = dlg.ShowModal()
	t= dlg.Get_Txt()
	dlg.Destroy()
	if ret == wxID_OK:
	    add_note(self.d_click, t )
	    add_mark(self.d_click, MARK_NOTE, self.d_click.GetYear())
	elif ret == FALSE:
	    remove_note(self.d_click)
	    remove_mark(self.d_click, MARK_NOTE, self.d_click.GetYear())
	elif ret ==wxID_CANCEL:
	    return
	Val.Cal.Draw_Mark()

    def OnTablet(self, event):
	if self.d_click in cycle.tablet:
	    cycle.tablet.remove(self.d_click)
	    remove_mark(self.d_click, MARK_TABLET, self.d_click.GetYear())
	else:
	    cycle.tablet.append(self.d_click)
	    cycle.tablet.sort()
	    add_mark(self.d_click, MARK_TABLET, self.d_click.GetYear())
	Val.Cal.Draw_Mark()
    
   


    def OnKey(self, event):
	k=event.GetKeyCode()
	if k==WXK_LEFT or k==WXK_RIGHT or \
	   k==WXK_UP or k==WXK_DOWN:
	    pass
	else:
	    event.Skip()
	    

#-------------------- class Cal_Year -------------------
class Cal_Year(wxScrolledWindow):
    def __init__(self, parent):
	wxScrolledWindow.__init__(self, parent,-1)
#	self.SetScrollbars(20, 20, 39, 40)
	self.SetBackgroundColour(wxNamedColour('LIGHT BLUE'))
	
	dt=wxDateTime_Today()
	self.year=dt.GetYear()

	self.day_of_year=[]
	self.month=[]
	Val.Cal=self
	self.Init_Year()
#	self.Draw_Mark()


    def Inc_Year(self):
	self.year += 1
	self.Draw_Year()
	reset_mark(self.year)
	self.Draw_Mark()

    def Dec_Year(self):
	self.year -= 1
	self.Draw_Year()
	reset_mark(self.year)
	self.Draw_Mark()

    def Set_Year(self,year):
	self.year=year
	self.Draw_Year()
	reset_mark(self.year)
	self.Draw_Mark()


    def Init_Year(self):
	m=0
	box = wxBoxSizer(wxVERTICAL)
	box.Add(wxStaticLine(self,-1,style=wxLI_HORIZONTAL), 0, wxEXPAND )
	for y in range(3):
	    row_box=wxBoxSizer(wxHORIZONTAL)
	    for x in range(4):
		t=wxDateTimeFromDMY(1, m, self.year)
		id=wxNewId()
		self.month.append(Month_Cal(self, id, t, ))
		row_box.Add(self.month[m], 0, wxALL, 5)
		m+=1
	    box.Add(row_box, 0, wxLEFT|wxRIGHT, 10)
	
	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)
	w = box.GetSize().GetWidth()
	h = box.GetSize().GetHeight()
	Val.frame.SetSize( wxSize(w+10,h+90) )
	self.SetScrollbars(20, 20, w/20, h/20)

    def Draw_Year(self):
	Val.frame.SetTitle(cycle.name+" - "+str(self.year))
	for m in range(12):
	    t=wxDateTimeFromDMY(1, m, self.year)
	    self.month[m].EnableYearChange(TRUE)
	    self.month[m].EnableMonthChange(TRUE)
	    self.month[m].SetDate(t)
	    self.month[m].EnableYearChange(FALSE)
	    self.month[m].EnableMonthChange(FALSE)
	    self.month[m].Refresh()

    def Draw_Mark(self):
	if wxPlatform == '__WXMSW__':
	    font_size=8
	else:
	    font_size=12
	f_norm=wxFont(font_size, wxSWISS, wxNORMAL, wxNORMAL, underline=FALSE)
	f_ul=wxFont(font_size, wxSWISS , wxNORMAL, wxNORMAL, underline=TRUE)
	#f_bold=wxFont(font_size, wxSWISS , wxNORMAL, wxBOLD, underline=FALSE)

	dt=wxDateTime_Today()
	if self.year==dt.GetYear():
	    add_mark(dt, MARK_TODAY, self.year)

	calc_fert(self.year)
	calc_tablet(self.year)
	k=1
	for m in range(12):
	    sel_hide=TRUE# need hide selection
	    for d in range(1,wxDateTime_GetNumberOfDaysInMonth(m, self.year)+1):
		can_hide=TRUE
		lab=cycle.mark.get(k,0)
		at=self.month[m].GetAttr(d)
		if at is None :
		    at=wxCalendarDateAttr(wxBLACK)
		    self.month[m].SetAttr(d,at)
		
		# reset attributes
		at.SetBorder(wxCAL_BORDER_NONE)
		at.SetBackgroundColour(wxWHITE)
		at.SetTextColour(wxBLACK)
		at.SetFont(f_norm)
		
		dt=wxDateTimeFromDMY(d, m, self.year)
		if not dt.IsWorkDay(): # mark weekend
		    at.SetTextColour(wxNamedColour('firebrick'))

		if lab & MARK_BEGIN:
		    at.SetBackgroundColour(wxRED)
		    at.SetTextColour(wxWHITE)
		
		if lab & MARK_PROG:
		    at.SetBackgroundColour(wxNamedColour('pink'))
		    at.SetTextColour(wxBLACK)

		if lab & MARK_SAFESEX and (cycle.disp==0 or cycle.disp==2):
		    at.SetBackgroundColour(wxNamedColour('wheat'))
		    
		if lab & MARK_FERT and (cycle.disp==1 or cycle.disp==2):
		    at.SetBackgroundColour(wxNamedColour('green yellow'))

		if lab & MARK_OVUL and (cycle.disp==1 or cycle.disp==2):
		    at.SetBackgroundColour(wxNamedColour('SPRING GREEN'))
	        
		if lab & MARK_TODAY :
		    at.SetBorderColour(wxNamedColour('NAVY'))
		    at.SetBorder(wxCAL_BORDER_SQUARE)
		    can_hide=FALSE

		if lab & MARK_LAST :
		    at.SetBackgroundColour(wxNamedColour('MAGENTA'))

		if lab & MARK_NOTE:
		    at.SetFont(f_ul)
		    can_hide=FALSE

   		if lab & MARK_BIRTH :
		    at.SetBackgroundColour(wxNamedColour('SPRING GREEN'))
		    
   		if lab & MARK_TABLET :
		    at.SetBackgroundColour(wxNamedColour('gold'))
		
   		if lab & MARK_T22_28 :
		    at.SetBackgroundColour(wxNamedColour('light blue'))
   		
		if lab & MARK_NEXT_TABLET :
		    at.SetBackgroundColour(wxNamedColour('pink'))
		
		if sel_hide and can_hide:
		    #we can hide selection when don't use border and underlined
		    sel_hide=FALSE
		    self.month[m].SetDate(dt)
		    self.month[m].SetHighlightColours(at.GetTextColour(),
				at.GetBackgroundColour())

		k+=1

	# so visual refresh is more fast
	for m in range(12):
	    self.month[m].Refresh()


#-------------------- work with cycle -------------------
class cycle:
    begin=[]
    last=[]
    tablet=[]
    period=28
    mark={}
    passwd="123"
    name="empty"
    by_average=FALSE
    disp=0
    first_week_day=0
    note={}


def min_max(i):
    """Return length max and min of 6 last cycles
    from i item cycle.begin"""

    if len(cycle.begin)<2 or i==0:
	return cycle.period, cycle.period

    last_6=[]
    for k in range(i,0,-1):
	span=(cycle.begin[k]-cycle.begin[k-1]+wxTimeSpan_Hours(1)).GetDays()
	# wxTimeSpan_Hours(1) -      
	if 20 < span <36: #     
	    last_6.append(span)
	    if len(last_6)>=6: break

    if cycle.by_average and len(last_6) != 0:
	s=float(reduce( operator.add, last_6 )) # sum of last_6
	cycle.period=int(round(s/len(last_6),0))
	
    if last_6==[]:
	return cycle.period, cycle.period
    return min(last_6),max(last_6)


def calc_fert(year):
    """    year"""

#    cycle.fert=[] #   
#    cycle.prog_begin=[] #   

    for k in cycle.mark.keys():
	cycle.mark[k]=cycle.mark[k] & ~MARK_FERT &\
	~MARK_OVUL & ~MARK_PROG & ~MARK_SAFESEX & ~MARK_BIRTH &\
	~MARK_T22_28 & ~MARK_NEXT_TABLET
    
    #  
    if cycle.begin==[]: return
    year_b=wxDateTimeFromDMY(1, 0, year)
    year_e=wxDateTimeFromDMY(31, 11, year)
    for d in cycle.begin:
	i=cycle.begin.index(d)
	if i<len(cycle.begin)-1:
	    if (cycle.begin[i+1]-cycle.begin[i]+wxTimeSpan_Hours(1)).GetDays()<21:
		# wxTimeSpan_Hours(1) -      
		#  
		continue

	min, max = min_max(i)
	begin = d+wxDateSpan_Days( min-18 ) # begin fertile
	end = d+wxDateSpan_Days( max-11 ) # end fertile
        ovul=end-wxDateSpan_Days(((max-11)-(min-18))/2) #day of ovul
	if year_b<=ovul<=year_e:
	    add_mark(ovul, MARK_OVUL, year)

	start=d+wxDateSpan_Day()
	if i<len(cycle.begin)-1:
	    last_cycle=(cycle.begin[i+1]-cycle.begin[i]+wxTimeSpan_Hours(1)).GetDays()
	    if last_cycle>35:
		stop=d+wxDateSpan_Days( 35 )
	    else:
		stop=cycle.begin[i+1]-wxDateSpan_Day()
	else:
	    stop=d+wxDateSpan_Days( cycle.period-1 )

	if (stop<year_b or start>year_e) and (d not in cycle.last):
	    continue
	f=start
	while f.IsBetween(start, stop):
	    if f.IsBetween(begin, end):
		add_mark(f, MARK_FERT, year)
	    else:
		add_mark(f, MARK_SAFESEX, year)
	    f+=wxDateSpan_Day()
	
	if d in cycle.last: # calc birthday
	    birth = d+wxDateSpan_Days(280+cycle.period-28)
	    if i<len(cycle.begin)-1: # not last item
		if birth < cycle.begin[i+1]:
		    add_mark(birth, MARK_BIRTH, year)
	    else: #last item
		add_mark(birth, MARK_BIRTH, year)
		return
		
    # prognosis to future cycles
    cycle.prog_begin=[]
    d+=wxDateSpan_Days( cycle.period )
    while d.GetYear()<=year:
	if cycle.tablet<>[] and cycle.tablet[-1]<=d and \
	    cycle.begin[-1]<=cycle.tablet[-1]: return
	if d.GetYear()==year: 
	    #	    cycle.prog_begin.append(d)
	    add_mark(d, MARK_PROG, year)

	begin = d+wxDateSpan_Days( min-18 ) # 
	end = d+wxDateSpan_Days( max-11 ) # 
	ovul=end-wxDateSpan_Days(((max-11)-(min-18))/2) #day of ovul
	if year_b<=ovul<=year_e:
	    add_mark(ovul, MARK_OVUL, year)

	start=d+wxDateSpan_Day()
	stop=d+wxDateSpan_Days( cycle.period-1 )
	d+=wxDateSpan_Days( cycle.period )
	
        if stop<year_b or start>year_e : continue
	
	f=start
	while f.IsBetween(start, stop):
	    if f.IsBetween(begin, end):
		add_mark(f, MARK_FERT, year)
	    else:
		add_mark(f, MARK_SAFESEX, year)
	    f+=wxDateSpan_Day()


def calc_tablet(year):
    """calculation result of using hormonal tablets"""
    
    if cycle.tablet==[]: return
    year_b=wxDateTimeFromDMY(1, 0, year)
    year_e=wxDateTimeFromDMY(31, 11, year)
    for d in cycle.tablet:
	i=cycle.tablet.index(d)
	if i<len(cycle.tablet)-1:
	    if (cycle.tablet[i+1]-cycle.tablet[i]+wxTimeSpan_Hours(1)).GetDays()<28:
		#incorrect using - must more 28 days
		continue
	for k in range(28):
	    remove_mark(d+wxDateSpan_Days(k), MARK_PROG | MARK_FERT |
	    MARK_NEXT_TABLET | MARK_OVUL | MARK_SAFESEX | MARK_BIRTH, year)
        for k in range(21,28):
	    add_mark(d+wxDateSpan_Days(k), MARK_T22_28, year)
	add_mark(d+wxDateSpan_Days(28), MARK_NEXT_TABLET, year)
		

	    
def add_mark(date, mark, year):
    if date.GetYear()==year:
        k=date.GetDayOfYear()
	cycle.mark[k]=cycle.mark.get(k,0) | mark

def remove_mark(date, mark, year):
    if date.GetYear()==year:
        k=date.GetDayOfYear()
	cycle.mark[k]=cycle.mark.get(k,0) & ~mark


def is_set_mark(date, mark, year):
    if date.GetYear()==year:
        k=date.GetDayOfYear()
	return cycle.mark.get(k,0) & mark
    else:
	return FALSE


def reset_mark(year):
    cycle.mark.clear()
    for k in cycle.begin:
	if k.GetYear()==year:
	    add_mark(k, MARK_BEGIN, year)
    for k in cycle.last:
	if k.GetYear()==year:
	    add_mark(k, MARK_LAST, year)
    for k in cycle.tablet:
	if k.GetYear()==year:
	    add_mark(k, MARK_TABLET, year)
    for k in cycle.note.keys():
	if str(year)==k[0:4]:
	    d=wxDateTimeFromDMY(int(k[6:8]), int(k[4:6])-1, int(k[0:4]))
	    add_mark(d, MARK_NOTE, year)
    

def info(day):
    """     ."""

    s=day.Format('%d %B')
    if cycle.tablet<>[]:
	for d in cycle.tablet:
	    if day.IsBetween(d, d+wxDateSpan_Days(28)):
		t=(day-d+wxTimeSpan_Hours(1)).GetDays()+1
		s+=" - "
		if t<=28:
		    s+=_('tablet N ')+str(t)
		if 22<= t <=28:
		    s+=_(' or pause')
		if t==29:
		    s+=_('next 1-st tablet')
		return s
    
    if cycle.begin==[]: return s
    if day<cycle.begin[0]: return s #    

    find=0
    gestation=0
    for d in cycle.begin:
	if day<d:
	    find=1
	    break

    if find==0:
	if d in cycle.last:
	    gestation=1
	    d2=d
	else:
	    #   
	    while d<=day:
		if cycle.tablet<>[] and cycle.tablet[-1]<=d and \
		    cycle.begin[-1]<=cycle.tablet[-1]: return s
		d+=wxDateSpan_Days(cycle.period)
	    find=2


    #   
    if find==1:
	i=cycle.begin.index(d)
	d2=cycle.begin[i-1]
	if d2 in cycle.last:
	    gestation=1
    elif find==2:
        d2=d-wxDateSpan_Days(cycle.period)
    
    if gestation:
	k=(day-d2+wxTimeSpan_Hours(1)).GetDays()+1
	w=(k-1)/7
	s+=" - "+str(k)+_(' day of gestation, ')+str(w)
	if w == 1: s+=_(' week')
	else: s+=_(' weeks')
	s+=' + '+str(k-w*7)
	if (k-w*7) == 1: s+=_(' day')
	else: s+=_(' days')
    else:
	p=(d-d2+wxTimeSpan_Hours(1)).GetDays()
	k=(day-d2+wxTimeSpan_Hours(1)).GetDays()+1

	d-=wxDateSpan_Day()
	s+=" - "+str(k)+_(' day of period from ')+d2.Format('%d %b')+_(' to ')+\
	    d.Format('%d %b')+_(' length ')+str(p)+_(' days')
    return s


#-------------------- Note --------------------
def add_note(date,txt):
    d=date.Format('%Y%m%d')
    cycle.note[d]=txt

def get_note(date):
    d=date.Format('%Y%m%d')
    return cycle.note.get(d,"")

def remove_note(date):
    d=date.Format('%Y%m%d')
    if cycle.note.has_key(d):
	del cycle.note[d]

#-------------------- Report --------------------
def report_year(year):
    if cycle.first_week_day == 0:
	calendar.setfirstweekday(calendar.MONDAY)
	days = range(1,7) + [0]
    else:
	calendar.setfirstweekday(calendar.SUNDAY)
	days = range(7)
    #sp=' '
    s='<html><body><H3 align=center>%s</H3><tt>' % year
    dn = ''
    for i in days:
	dn += '%.2s ' % wxDateTime_GetWeekDayName(i, wxDateTime.Name_Abbr)
    dn = dn[:-1]
    dn = '%s  %s  %s<br>\n' % (dn, dn, dn)  # week days names
    for m in range(0,12,3):
	s += '<br>\n%s  %s  %s<br>\n' % (
	    wxDateTime_GetMonthName( m ).center(20),
	    wxDateTime_GetMonthName( m+1 ).center(20),
	    wxDateTime_GetMonthName( m+2 ).center(20) )
	s += dn
	data = []
	h = 0
	for k in range(m+1, m+4):
	    cal = calendar.monthcalendar(year, k)
	    data.append( calendar.monthcalendar(year, k) )
	    if h < len(cal):
		h = len(cal)
	for i in range(h):
	    d_str = ''
	    for n in range(3):
		for k in range(7):
		    if i< len(data[n]):
			day_of_month = data[n][i][k]
			if day_of_month:
			    d = wxDateTimeFromDMY(day_of_month, m+n, year)
			    if is_set_mark(d, MARK_BEGIN, d.GetYear()):
				d_str += '<u>%2s</u> ' % day_of_month
			    else:
				d_str += '%2s ' % day_of_month
			else:
			    d_str += '   '
		    else:
			d_str += '   '
		d_str += ' '
	    s += d_str[:-2] +'<br>\n'
    

    s+='</tt></body></html>'
    print s
    return s

#-------------------- Add import --------------------
from dialogs import Note_Dlg 
   
