#!/usr/bin/env python
#====================================================
#	Cycle - calendar for women
#	Distributed under GNU Public License
# Author: Oleg S. Gints (go@altlinux.ru)
# Home page: http://conero.lrn.ru
#====================================================
import os, sys, gettext
import locale
from wxPython.wx import *
from wxPython.html import *

from cal_year import *
from save_load import *
from dialogs import *
from set_dir import *

import gettext
import __builtin__
lang_find=0
if os.environ.has_key('LANGUAGE'):
    env_language=os.environ['LANGUAGE']
    for s_lang in env_language.split(':'): # if set more languages
	os.environ['LANGUAGE']=s_lang
	try:
	    dl=locale.getdefaultlocale()
	    lang=[ dl[0][0:2] ]
	    l=gettext.translation('cycle', msg_dir, lang)
	    __builtin__.__dict__['_'] = lambda s: l.ugettext(s).encode(dl[1])
	    _('try decode this string')
	    lang_find=1
	    break #language is finded
	except:
	    pass
else: #for Windows
    try:
        dl=locale.getdefaultlocale()
        lang=[ dl[0][0:2] ]
	l=gettext.translation('cycle', msg_dir, lang)
	__builtin__.__dict__['_'] = lambda s: l.ugettext(s).encode(dl[1])
	_('try decode this string')
	lang_find=1
    except:
        pass

if not lang_find:
    __builtin__.__dict__['_'] = lambda s: s
    lang=[""]


class MyFrame(wxFrame):
    def __init__(self, parent, ID, title):
	wxFrame.__init__(self, parent, ID, title,
		       wxDefaultPosition, wxSize(800, 600))

	wxImage_AddHandler(wxPNGHandler())
	self.printer = wxHtmlEasyPrinting()
	icon = wxIcon(os.path.join(icons_dir,'mini/cycle.xpm'), wxBITMAP_TYPE_XPM)
	self.SetIcon(icon)

	Val.frame=self
	self.CreateStatusBar()
        self.MakeToolMenu()  # toolbar
	
	self.cal=Cal_Year(self)
	self.OnCurrent(self)
	EVT_CLOSE(self, self.OnCloseWindow)

    def OnCloseWindow(self, event):
	Save_Cycle(cycle.name, cycle.passwd)
	self.Destroy()

    def TimeToQuit(self, event):
	self.Close(true)

    def MakeToolMenu(self):
	tb = self.CreateToolBar(wxTB_HORIZONTAL|wxNO_BORDER)
	tb.SetToolBitmapSize( wxSize(24,24) )

	bmp_path = 'bitmaps/'

	SetToolPath(self, tb, 10, bmp_path + 'dec.png', _('Dec Year'))
	EVT_TOOL(self, 10, self.OnDecYear)

	SetToolPath(self, tb, 20, bmp_path + 'curr.png', _('Current Year'))
	EVT_TOOL(self, 20, self.OnCurrent)

	SetToolPath(self, tb, 30, bmp_path + 'inc.png', _('Inc Year'))
	EVT_TOOL(self, 30, self.OnIncYear)

	tb.SetToolSeparation(50)
	tb.AddSeparator()
	
	SetToolPath(self, tb, 40, bmp_path + 'legend.png', _('Legend'))
	EVT_TOOL(self, 40, self.Legend)
	
	SetToolPath(self, tb, 50, bmp_path + 'set.png', _('Settings'))
	EVT_TOOL(self, 50, self.Settings)
	
	SetToolPath(self, tb, 55, bmp_path + 'help.png', _('Help'))
	EVT_TOOL(self, 55, self.Info)

#	SetToolPath(self, tb, 57, bmp_path + 'help.png', _('Print'))
#	EVT_TOOL(self, 57, self.PrintRep)

	tb.AddSeparator()

	SetToolPath(self, tb, 60, bmp_path + 'exit.png', _('Exit'))
	EVT_TOOL(self, 60, self.TimeToQuit)

	tb.Realize()

    def PrintRep(self, event):
	rpt = report_year(self.cal.year)
	#self.printer.PreviewText(rpt)
	self.printer.PreviewFile('2.html')

    def Legend(self,event):
	dlg = Legend_Dlg(self)
        dlg.ShowModal()
	dlg.Destroy()
        
    def Settings(self,event):
	dlg = Settings_Dlg(self)
        if dlg.ShowModal() == wxID_OK:
	    self.cal.Set_Year(wxDateTime_Today().GetYear())
        dlg.Destroy()

    def Info(self, event):
	global lang
	f_name=os.path.join(doc_dir,"README_"+lang[0]+".html")
	if not os.path.isfile(f_name):
	    f_name=os.path.join(doc_dir,"README.html")
	f = open(f_name, "r")
	msg = f.read()
	dlg = Help_Dlg(self, _('Help'), msg)
	dlg.ShowModal()


    # increment and decrement toolbar controls
    def OnIncYear(self, event):
        self.cal.Inc_Year()

    def OnDecYear(self, event):
        self.cal.Dec_Year()

    def OnCurrent(self, event):
	self.cal.Set_Year(wxDateTime_Today().GetYear())



#----------------------------------------------
def SetToolPath(self, tb, id, bmp, title):
    global dir_path
    tb.AddSimpleTool(id, wxBitmap(os.path.join(dir_path, bmp), wxBITMAP_TYPE_PNG),
                     title, title)


class MyApp(wxApp):
    def OnInit(self):
	ret=first_login()
	if ret=='bad_login':
	    return TRUE
	elif ret=='not_first':
	    dlg = Login_Dlg(NULL)
	    if dlg.ShowModal() == wxID_CANCEL:
		dlg.Destroy()
		return TRUE
	    dlg.Destroy()
	self.frame_init()
	return TRUE

    def frame_init(self):
	frame = MyFrame(NULL, -1,"")
	frame.Show(true)
	self.SetTopWindow(frame)

if __name__=='__main__':
    locale.setlocale(locale.LC_ALL,"")
    dir_path = os.getcwd()
    app = MyApp(0)
    app.MainLoop()

