#====================================================
#	Cycle - calendar for women
#	Distributed under GNU Public License
# Author: Oleg S. Gints (go@altlinux.ru)
# Home page: http://conero.lrn.ru
#====================================================
import os
from wxPython.wx import *
from wxPython.html import *
from cal_year import cycle #, Val
from save_load import Load_Cycle, get_f_name

#---------------------------------------------------------------------------
class Settings_Dlg(wxDialog):
    def __init__(self, parent):
	wxDialog.__init__(self,parent,-1, _('Settings'), wxPyDefaultPosition)
	self.Centre(wxBOTH)
	#======================
	box = wxBoxSizer(wxVERTICAL)
        
	b1=wxStaticBoxSizer(wxStaticBox(self,-1,_('Length of cycle')),wxVERTICAL)
	i=wxNewId()
	self.cb1 = wxCheckBox(self, i, _(' by average'), style=wxNO_BORDER)
	b1.Add(self.cb1, 0, wxALL, 5)
	EVT_CHECKBOX(self, i, self.By_Average)
	self.cb1.SetValue(cycle.by_average)

	b2 = wxBoxSizer(wxHORIZONTAL)
	i=wxNewId()
	self.sc = wxSpinCtrl(self, i, "", size=wxSize(50, -1))
        self.sc.SetRange(21,35)
        self.sc.SetValue(cycle.period)
	self.sc.Enable(not self.cb1.GetValue())
	b2.Add(self.sc, 0)
	b2.Add(wxStaticText(self, -1, _(' days in cycle')), 0)
	b1.Add(b2, 0, wxALL, 5)
	box.Add(b1, 0, wxEXPAND|wxTOP|wxLEFT|wxRIGHT, 10)
	#======================
	self.rb = wxRadioBox(self, -1, _('Display'),
	    choices=[_('safe sex days'),_('fertile days'),_('both')],
	    majorDimension=1, style=wxRA_SPECIFY_COLS)
	box.Add(self.rb, 0, wxEXPAND|wxTOP|wxLEFT|wxRIGHT, 10)
	self.rb.SetSelection(cycle.disp)

	#======================
	self.rb1 = wxRadioBox(self, -1, _('First week day'),
	    choices=[_('monday'),_('sunday')],
	    majorDimension=1, style=wxRA_SPECIFY_COLS)
	box.Add(self.rb1, 0, wxEXPAND|wxALL, 10)
	self.rb1.SetSelection(cycle.first_week_day)

	#======================
	i=wxNewId()
	txt=_('Change password')
	w,h=self.GetTextExtent(txt)
	box.Add(wxButton(self, i, txt, size=wxSize(w+10, -1)), 0, wxALIGN_CENTER)
	EVT_BUTTON(self, i, self.OnChangePasswd)

	#======================
	but_box=wxBoxSizer(wxHORIZONTAL)
	i=wxNewId()
	but_box.Add(wxButton(self, i, _('Ok')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnOk)
	
	i=wxNewId()
	but_box.Add(wxButton(self, i, _('Cancel')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnCancel)

	box.Add(but_box, 0, wxALIGN_CENTER)

	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)

    def By_Average(self, event):
	if event.Checked():
	    self.sc.Enable(FALSE)
	else:
	    self.sc.Enable(TRUE)

    def OnOk(self, event):
	if not 21<=self.sc.GetValue()<=35:
	    dlg = wxMessageDialog(self, _('Period of cycle is invalid!'),
            _('Error!'), wxOK |wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()
	    return
	cycle.period=self.sc.GetValue()
	cycle.by_average=self.cb1.GetValue()
	cycle.disp=self.rb.GetSelection()
	cycle.first_week_day=self.rb1.GetSelection()
	self.EndModal(wxID_OK)

    def OnCancel(self, event):
	self.EndModal(wxID_CANCEL)

    def OnChangePasswd(self, event):
        dlg = Ask_Passwd_Dlg(self)
        dlg.ShowModal()
	dlg.Destroy()

#---------------------------------------------------------------------------
class Ask_Passwd_Dlg(wxDialog):
    def __init__(self, parent):
	wxDialog.__init__(self,parent,-1, _('Password'))

	#======================
	box = wxBoxSizer(wxVERTICAL)
        
	box.Add(wxStaticText(self, -1, _('Enter your password')), 0,
	    wxALIGN_CENTER|wxTOP|wxLEFT|wxRIGHT, 10)
	self.pass1 = wxTextCtrl(self, -1, "", wxPoint(10, 30),
		size=(130, -1), style=wxTE_PASSWORD)
	box.Add(self.pass1, 0, wxALIGN_CENTER|wxALL, 10)
	
	box.Add(wxStaticText(self, -1, _('Once more...')), 0,
	    wxALIGN_CENTER|wxLEFT|wxRIGHT, 10)
	self.pass2 = wxTextCtrl(self, -1, "", wxPoint(10, 80),
		size=(130, -1), style=wxTE_PASSWORD)
	box.Add(self.pass2, 0, wxALIGN_CENTER|wxALL, 10)
	

	b1=wxBoxSizer(wxHORIZONTAL)
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Ok')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnOk)
	
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Cancel')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnCancel)
	self.pass1.SetFocus()
	box.Add(b1, 0, wxALIGN_CENTER)

	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)
	

    def OnOk(self, event):
	err=""
	if self.pass1.GetValue()=="" or self.pass2.GetValue()=="":
	    err=_('Password must be not EMPTY!')
	if self.pass1.GetValue() != self.pass2.GetValue():
	    err=_('Entering password don\'t match!')
	if err !=  "":
	    dlg = wxMessageDialog(self, err,
            _('Error!'), wxOK |wxICON_ERROR )
	    dlg.ShowModal()
	    dlg.Destroy()
	    return
	cycle.passwd=self.pass1.GetValue()
	self.EndModal(wxID_OK)

    def OnCancel(self, event):
	self.EndModal(wxID_CANCEL)

#---------------------------------------------------------------------------
class Login_Dlg(wxDialog):
    def __init__(self, parent):
	wxDialog.__init__(self,parent,-1, _('Login'))
	
	self.name=""
	box = wxBoxSizer(wxVERTICAL)

	#Get list of users
	p, f_name=get_f_name()
	if os.path.exists(p):
	    users=os.listdir(p)
	else:
	    users=[_('empty')]
    	users.sort()
	
	#======== List users ==============
	i = wxNewId()
        self.il = wxImageList(16, 16,TRUE)
	bmp=wxBitmap('bitmaps/smiles.bmp', wxBITMAP_TYPE_BMP)
	mask = wxMaskColour(bmp, wxWHITE)
	bmp.SetMask(mask)
	
	idx1 = self.il.Add(bmp)

        self.list = wxListCtrl(self, i, size=wxSize(200, 200),
                   style=wxLC_REPORT|wxSUNKEN_BORDER|wxLC_SINGLE_SEL)
        self.list.SetImageList(self.il, wxIMAGE_LIST_SMALL)
	self.list.InsertColumn(0, _('Your name'))
	for k in range(len(users)):
	    self.list.InsertImageStringItem(k, users[k], idx1)
	self.list.SetColumnWidth(0, 180)
	self.list.SetItemState(0, wxLIST_STATE_SELECTED, wxLIST_STATE_SELECTED)
	self.name=users[0]
	
	EVT_LIST_ITEM_SELECTED(self, i, self.OnItemSelected)
	EVT_KEY_DOWN(self.list, self.OnKeyDown)
	
	box.Add(self.list, 0, wxALL, 10)
        #========= Add user =============
	
	i=wxNewId()
	box.Add(wxButton(self, i, _('Add user')), 0, wxALIGN_CENTER)
	EVT_BUTTON(self, i, self.OnAdd)
	
	#========= Ok - Cancel =============
	b1=wxBoxSizer(wxHORIZONTAL)
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Ok')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnOk)
	
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Cancel')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnCancel)
	box.Add(b1, 0, wxALIGN_CENTER)

	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)
	self.list.SetFocus()

    def OnItemSelected(self, event):
	self.name=self.list.GetItemText(event.GetIndex())    
    
    def OnKeyDown(self, event):
	if event.GetKeyCode()==ord(" ") or event.GetKeyCode()==WXK_RETURN:
	    self.OnOk()
	else:
	    event.Skip()


    def OnAdd(self, event=NULL):
	if ask_name(self):
	    self.EndModal(wxID_OK)


    def OnOk(self, event=NULL):
	dlg = wxTextEntryDialog(self, self.name+_(', enter you password:'),_('Password'),'',
	     style=wxOK | wxCANCEL |  wxTE_PASSWORD)
	while dlg.ShowModal() == wxID_OK:
	    cycle.passwd=dlg.GetValue()
	    cycle.name=self.name
	    if Load_Cycle(self.name, cycle.passwd):
		dlg.Destroy()
		self.EndModal(wxID_OK)
		return
	    else:
		dlg2 = wxMessageDialog(self, _('Password is invalid!'),
		    _('Error!'), wxOK |wxICON_ERROR )
		dlg2.ShowModal()
		dlg2.Destroy()
        dlg.Destroy()
	
    def OnCancel(self, event):
	self.EndModal(wxID_CANCEL)

#-------------------------------------------------------
def first_login():
    #Get list of users
    p, f_name=get_f_name()
    if os.path.exists(p):
	users=os.listdir(p)
	if users != []:
	    return 'not_first' #user(s) already exist
    if ask_name():
	return 'first'
    else:
	return 'bad_login'

#-------------------------------------------------------
def ask_name(parent=None):
    # nobody, it is first login
    dlg = wxTextEntryDialog(parent, _('Enter you name:'),_('New user'),'',
	 style=wxOK | wxCANCEL)
    while dlg.ShowModal()==wxID_OK:
	name=dlg.GetValue()
	if name != "":
	    p, f_name=get_f_name(name)
	    if not os.path.isfile(f_name):
		d=Ask_Passwd_Dlg(parent)
		if d.ShowModal()==wxID_OK:
		    cycle.name=name
		    d.Destroy()
		    dlg.Destroy()
		    #self.EndModal(wxID_OK)
		    return TRUE
		else:
		    d.Destroy()
		    continue
	    else:
		err=name+_(' - already is exist!')
	else:
	    err=_('Name must be not EMPTY')
	d2 = wxMessageDialog(dlg, err,	_('Error!'), wxOK |wxICON_ERROR )
	d2.ShowModal()
	d2.Destroy()
	
    dlg.Destroy()
    return FALSE


#---------------------------------------------------------------------------
class Legend_Dlg(wxDialog):
    def __init__(self, parent):
	wxDialog.__init__(self,parent,-1, _('Legend'))

	#======================
	box = wxBoxSizer(wxVERTICAL)

	self._add(box, _('today'), wxNullColour,wxSIMPLE_BORDER)
	self._add(box, _('begin of cycle'), wxNamedColour('red'))
	self._add(box, _('prognosis of cycle begin'), wxNamedColour('pink'))
	self._add(box, _('conception'), wxNamedColour('MAGENTA'))
	self._add(box, _('safe sex'), wxNamedColour('wheat'))
	self._add(box, _('fertile'), wxNamedColour('green yellow'))
	self._add(box, _('ovule, birth'), wxNamedColour('SPRING GREEN'))
	self._add(box, _('1-st tablet'), wxNamedColour('gold'))
	self._add(box, _('tablets N 22-28 or pause'), wxNamedColour('light blue'))
	self._add(box, _('next 1-st tablet'), wxNamedColour('pink'))
	
	i=wxNewId()
	box.Add(wxButton(self, i, _('Ok')), 0, wxALIGN_CENTER|wxALL, 10)
	EVT_BUTTON(self, i, self.OnOk)
	
	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)
	
    def _add(self,box,txt,col,st=0):
	b=wxBoxSizer(wxHORIZONTAL)
        w=wxWindow(self,-1,size=wxSize(15,15),style=st)
	w.SetBackgroundColour(col)
	b.Add(w, 0, wxLEFT|wxRIGHT,10)
	b.Add(wxStaticText(self, -1, txt), 0, wxALIGN_CENTER_VERTICAL|wxRIGHT, 10)
	box.Add(b, 0, wxTOP, 10)


    def OnOk(self, event):
	self.EndModal(wxID_OK)

#---------------------------------------------------------------------------
class Note_Dlg(wxDialog):
    def __init__(self, parent, title="",txt=""):
	wxDialog.__init__(self,parent,-1, title)
	self.CentreOnParent(wxBOTH)

	#======================
	box = wxBoxSizer(wxVERTICAL)
	self.txt=wxTextCtrl(self, -1, txt,
                       size=(-1, 100), style=wxTE_MULTILINE)
        box.Add( self.txt, 0,
	    wxEXPAND|wxALIGN_CENTER|wxTOP|wxLEFT|wxRIGHT, 10)

	b1=wxBoxSizer(wxHORIZONTAL)
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Ok')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnOk)
	
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Cancel')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnCancel)
	
	i=wxNewId()
	b1.Add(wxButton(self, i, _('Remove')), 0, wxALL, 10)
	EVT_BUTTON(self, i, self.OnRemove)
	box.Add(b1, 0, wxALIGN_CENTER)
	
	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)
	self.txt.SetFocus()
	

    def OnOk(self, event):
	self.EndModal(wxID_OK)

    def OnCancel(self, event):
	self.EndModal(wxID_CANCEL)

    def OnRemove(self, event):
	self.EndModal(FALSE)

    def Get_Txt(self):
	return self.txt.GetValue()
    
#---------------------------------------------------------------------------
class MyHtmlWindow(wxHtmlWindow):
    def __init__(self, parent, id, pos = wxDefaultPosition, size=wxDefaultSize):
	wxHtmlWindow.__init__(self, parent, id, pos, size)

    def OnLinkClicked(self, linkinfo):
	pass
	
#---------------------------------------------------------------------------
class Help_Dlg(wxDialog):
    def __init__(self, parent, title="",txt=""):
	wxDialog.__init__(self,parent,-1, title)
	self.CentreOnParent(wxBOTH)

	#======================
	box = wxBoxSizer(wxVERTICAL)
	self.html=MyHtmlWindow(self, -1, size=(500, 350))
	self.html.SetPage(txt)
        box.Add( self.html, 0, wxALIGN_CENTER|wxTOP|wxLEFT|wxRIGHT, 10)

	i=wxNewId()
	box.Add(wxButton(self, i, _('Ok')), 0, wxALIGN_CENTER|wxALL, 10)
	EVT_BUTTON(self, i, self.OnOk)
		
	self.SetAutoLayout(true)
        self.SetSizer(box)
	box.Fit(self)
	
    def OnOk(self, event):
	self.EndModal(wxID_OK)
