#====================================================
#	Cycle - calendar for women
#	Distributed under GNU Public License
# Author: Oleg S. Gints (go@altlinux.ru)
# Home page: http://conero.lrn.ru
#====================================================
from wxPython.wx import *
import os, os.path , cPickle, rotor, md5
import cal_year

def Save_Cycle(name='cycle', passwd='123'):
    """ Save the contents of our document to disk.
    """
    objSave=[]
    m=md5.new()
    m.update(passwd)
    rt=rotor.newrotor(m.digest())
    objSave.append(['period', cal_year.cycle.period])
    objSave.append(['by_average', cal_year.cycle.by_average])
    objSave.append(['disp', cal_year.cycle.disp])
    objSave.append(['first_week_day', cal_year.cycle.first_week_day])
    objSave.append(['note', cal_year.cycle.note])
    for d in cal_year.cycle.begin:
	objSave.append(['begin',[d.GetDay(), d.GetMonth(), d.GetYear()]])
   
    for d in cal_year.cycle.last:
	objSave.append(['last',[d.GetDay(), d.GetMonth(), d.GetYear()]])
	
    for d in cal_year.cycle.tablet:
	objSave.append(['tablet',[d.GetDay(), d.GetMonth(), d.GetYear()]])
    
    tmp=rt.encrypt( 'Cycle'+cPickle.dumps(objSave) )
    p, f_name=get_f_name(name)

    if not os.path.exists(p):
	os.mkdir(p,0700)
    f=open(f_name,"wb")
    f.write(tmp)
    f.close()
#    print "All data saved to disk"


def Load_Cycle(name='cycle', passwd='123'):
    
    p, f_name=get_f_name(name)
    if os.path.isfile(f_name):
	m=md5.new()
	m.update(passwd)
	rt=rotor.newrotor(m.digest())
	f=open(f_name,"rb")
	tmp=rt.decrypt(f.read())
	f.close()
	if tmp[0:5]!='Cycle':
	    #	    print 'Password is invalid'
	    return FALSE
	else:
	    tmp=tmp[5:] #remove control word 'Cycle'
	    objLoad=cPickle.loads(tmp)
	    for type, d in objLoad:
		if type=='period':
		    cal_year.cycle.period=int(d)
		elif type=='by_average':
		    cal_year.cycle.by_average=int(d)
		elif type=='disp':
		    cal_year.cycle.disp=int(d)
		elif type=='first_week_day':
		    cal_year.cycle.first_week_day=int(d)
		elif type=='begin':
		    dt=wxDateTimeFromDMY(d[0], d[1], d[2])
		    cal_year.cycle.begin.append(dt)
		elif type=='last':
		    dt=wxDateTimeFromDMY(d[0], d[1], d[2])
		    cal_year.cycle.last.append(dt)
		elif type=='tablet':
		    dt=wxDateTimeFromDMY(d[0], d[1], d[2])
		    cal_year.cycle.tablet.append(dt)
		elif type=='note':
		    cal_year.cycle.note=d.copy()

	    return TRUE


#-------------------------------------------------------
def get_f_name(name=""):
    if wxPlatform == '__WXMSW__':
        p=os.getcwd()+"\\data"
        f_name=p+"\\"+name
    else:
	p=os.path.expanduser("~/.cycle")
	f_name=p+"/"+name

    return p, f_name
